Index: test/edu/ucsb/nceas/metacatnettest/MetaCatServletNetTest.java
===================================================================
--- test/edu/ucsb/nceas/metacatnettest/MetaCatServletNetTest.java	(revision 4079)
+++ test/edu/ucsb/nceas/metacatnettest/MetaCatServletNetTest.java	(revision 4080)
@@ -40,626 +43,531 @@
 
 import org.apache.log4j.Logger;
 
-
 /**
  * A JUnit test for testing Step class processing
  */
-public class MetaCatServletNetTest extends TestCase
-{
-  static
-  {
-	  try
-	  {
-		  Options.initialize(new File("build/tests/metacat.properties"));
-	  }
-	  catch(Exception e)
-	  {
-		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
-	  }
-  }
-  
-  private String metacatURL=MetaCatUtil.getOption("junittesturl");
-  private String serialNumber;
-  private static Logger logMetacat = Logger.getLogger(DocumentImpl.class);
-  /**
-   * Constructor to build the test
-   *
-   * @param name the name of the test method
-   */
-  public MetaCatServletNetTest(String name)
-  {
-    super(name);
-  }
+public class MetaCatServletNetTest extends TestCase {
+	private static String metacatURL;
+	static {
+		try {
+			metacatURL = SystemUtil.getServletURL();
+			Options.initialize(new File("build/tests/metacat.properties"));
+		} catch (PropertyNotFoundException pnfe) {
+			System.err.println("could not find metacat URL in MetacatServletNetTest: "
+					+ pnfe.getMessage());
+		} catch (Exception e) {
+			System.err.println("Exception in initialize option in MetacatServletNetTest: "
+					+ e.getMessage());
+		}
+	}
 
- /**
-   * Constructor to build the test
-   *
-   * @param name the name of the test method
-   */
-  public MetaCatServletNetTest(String name, String serial)
-  {
-    super(name);
-    serialNumber=serial;
-  }
-  /**
-   * Establish a testing framework by initializing appropriate objects
-   */
-  public void setUp()
- {
-    
- }
+	private String serialNumber;
+	private static Logger logMetacat = Logger.getLogger(DocumentImpl.class);
 
-  /**
-   * Release any objects after tests are complete
-   */
-  public void tearDown()
-  {
-  }
+	/**
+	 * Constructor to build the test
+	 *
+	 * @param name the name of the test method
+	 */
+	public MetaCatServletNetTest(String name) {
+		super(name);
+	}
 
-  /**
-   * Create a suite of tests to be run together
-   */
-  public static Test suite()
-  {
-    double number = 0;
-    String serial = null;
-    
-    
-    TestSuite suite = new TestSuite();
-    suite.addTest(new MetaCatServletNetTest("initialize"));
-    suite.addTest(new MetaCatServletNetTest("testNCEASLoginFail"));
-    //Should put a login successfully at the end of login test
-    //So insert or update can have cookie.
-    suite.addTest(new MetaCatServletNetTest("testNCEASLogin"));
-    
-    //create random number for docid, so it can void repeat
-    number = Math.random()*100000;
-    serial = Integer.toString(((new Double(number)).intValue()));
-    logMetacat.info("serial: "+serial);
-    suite.addTest(new MetaCatServletNetTest("testInsertXMLDocument", serial));
-    suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentXMLFormat", 
-                                                        serial));
-    suite.addTest(new MetaCatServletNetTest("testUpdateXMLDocument",serial));    
-    suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentHTMLFormat", 
-                                                        serial));
-    suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentZipFormat", 
-                                                        serial));
-    
-    suite.addTest(new MetaCatServletNetTest("testDeleteXMLDocument",serial));
-    
-    //insert invalid xml document
-    number = Math.random()*100000;
-    serial = Integer.toString(((new Double(number)).intValue()));
-    suite.addTest(new MetaCatServletNetTest("testInsertInvalidateXMLDocument",
-                                                                  serial));    
-    //insert non well formed document
-    number = Math.random()*100000;
-    serial = Integer.toString(((new Double(number)).intValue())); 
-   suite.addTest(new MetaCatServletNetTest("testInsertNonWellFormedXMLDocument",
-                                                            serial));
-    //insert data file  
-    number = Math.random()*100000;
-    serial = Integer.toString(((new Double(number)).intValue()));
-    suite.addTest(new MetaCatServletNetTest("testLogOut"));                   
-                              
-    return suite;
-  }
-  
+	/**
+	 * Constructor to build the test
+	 *
+	 * @param name the name of the test method
+	 */
+	public MetaCatServletNetTest(String name, String serial) {
+		super(name);
+		serialNumber = serial;
+	}
 
+	/**
+	 * Establish a testing framework by initializing appropriate objects
+	 */
+	public void setUp() {
 
-  /**
-   * Run an initial test that always passes to check that the test
-   * harness is working.
-   */
-  public void initialize()
-  {
-    assertTrue(1 == 1);
-  }
+	}
 
-  /**
-   * Test the login to neceas succesfully
-   */
-  public void testNCEASLogin()
-  {
-    String user="uid=john,o=NCEAS,dc=ecoinformatics,dc=org";
-    String passwd="123456";
-    assertTrue(logIn(user,passwd));
-    //assertTrue( withProtocol.getProtocol().equals("http"));
-  }
-  
-  /**
-   * Test the login to neceas failed
-   */
-  public void testNCEASLoginFail()
-  {
-    String user="uid=john,o=NCEAS,dc=ecoinformatics,dc=org";
-    String passwd="12345678";
-    assertTrue(!logIn(user,passwd));
-    
-  }
-  
+	/**
+	 * Release any objects after tests are complete
+	 */
+	public void tearDown() {
+	}
 
-  
-  /**
-   * Test the login to lter failed
-   */
-  public void testLterReferralLoginFail()
-  {
-    String user="uid=jtao,o=LTER,dc=ecoinformatics,dc=org";
-    String passwd="qVyGpveb";
-    assertTrue(!logIn(user,passwd));
-    //assertTrue( withProtocol.getProtocol().equals("http"));
-  }
-  
-  
- /**
-   * Test insert a xml document successfully
-   */
-  public void testInsertXMLDocument()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    logMetacat.info("insert docid: "+name);
-    String content="<?xml version=\"1.0\"?>"
-                   +"<!DOCTYPE acl PUBLIC \"-//ecoinformatics.org//"
-                   +"eml-access-2.0.0beta6//EN\" \"http://pine.nceas.ucsb."
-                   +"edu:8080/tao/dtd/eml-access-2.0.0beta6.dtd\">"
-                   +"<acl authSystem=\"knb\" order=\"allowFirst\">"
-                   +"<identifier>"+name+"</identifier>"
-                   +"<allow>"
-             +"<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
-                   +"<permission>all</permission>"
-                   +"</allow>"
-                   +"<allow>"
-                   +"<principal>public</principal>"
-                   +"<permission>read</permission>"
-                   +"</allow>"
-                   +"</acl>";
-    logMetacat.info("xml document: "+content);
-     assertTrue(handleXMLDocument(content, name, "insert"));
-   
-  }
-  
-  /**
-   * Test insert a invalidate xml document successfully
-   * In the String, there is no <!Doctype ... Public/System/>
-   */
-  public void testInsertInvalidateXMLDocument()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    logMetacat.info("insert docid: "+name);
-    String content="<?xml version=\"1.0\"?>"
-                   +"<acl authSystem=\"knb\" order=\"allowFirst\">"
-                   +"<identifier>"+name+"</identifier>"
-                   +"<allow>"
-             +"<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
-                   +"<permission>all</permission>"
-                   +"</allow>"
-                   +"<allow>"
-                   +"<principal>public</principal>"
-                   +"<permission>read</permission>"
-                   +"</allow>"
-                   +"</acl>";
-    logMetacat.info("xml document: "+content);
-     assertTrue(handleXMLDocument(content, name, "insert"));
-  }
-  
-   /**
-   * Test insert a non well-formed xml document successfully
-   * There is no </acl> in this string
-   */
-  public void testInsertNonWellFormedXMLDocument()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    logMetacat.info("insert non well-formed docid: "+name);
-    String content="<?xml version=\"1.0\"?>"
-                   +"<acl authSystem=\"knb\" order=\"allowFirst\">"
-                   +"<identifier>"+name+"</identifier>"
-                   +"<allow>"
-             +"<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
-                   +"<permission>all</permission>"
-                   +"</allow>"
-                   +"<allow>"
-                   +"<principal>public</principal>"
-                   +"<permission>read</permission>"
-                   +"</allow>";
-  
-     logMetacat.info("xml document: "+content);
-     assertTrue(!handleXMLDocument(content, name, "insert"));
-  } 
+	/**
+	 * Create a suite of tests to be run together
+	 */
+	public static Test suite() {
+		double number = 0;
+		String serial = null;
 
-  /**
-   * Test read a xml document  in xml format successfully
-   */
-  public void testReadXMLDocumentXMLFormat()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    assertTrue(handleReadAction(name, "xml"));
-   
-  } 
+		TestSuite suite = new TestSuite();
+		suite.addTest(new MetaCatServletNetTest("initialize"));
+		suite.addTest(new MetaCatServletNetTest("testNCEASLoginFail"));
+		//Should put a login successfully at the end of login test
+		//So insert or update can have cookie.
+		suite.addTest(new MetaCatServletNetTest("testNCEASLogin"));
 
-  /**
-   * Test read a xml document  in html format successfully
-   */
-  public void testReadXMLDocumentHTMLFormat()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    assertTrue(handleReadAction(name, "html"));
-   
-  }
+		//create random number for docid, so it can void repeat
+		number = Math.random() * 100000;
+		serial = Integer.toString(((new Double(number)).intValue()));
+		logMetacat.info("serial: " + serial);
+		suite.addTest(new MetaCatServletNetTest("testInsertXMLDocument", serial));
+		suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentXMLFormat", serial));
+		suite.addTest(new MetaCatServletNetTest("testUpdateXMLDocument", serial));
+		suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentHTMLFormat", serial));
+		suite.addTest(new MetaCatServletNetTest("testReadXMLDocumentZipFormat", serial));
 
- 
-  /**
-   * Test read a xml document  in zip format successfully
-   */
-  public void testReadXMLDocumentZipFormat()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    assertTrue(handleReadAction(name, "zip"));
-   
-  }
-  
-  /**
-   * Test insert a xml document successfully
-   */
-  public void testUpdateXMLDocument()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"2";
-    logMetacat.info("update docid: "+name);
-    String content="<?xml version=\"1.0\"?>"
-                   +"<!DOCTYPE acl PUBLIC \"-//ecoinformatics.org//"
-                   +"eml-access-2.0.0beta6//EN\" \"http://pine.nceas.ucsb."
-                   +"edu:8080/tao/dtd/eml-access-2.0.0beta6.dtd\">"
-                   +"<acl authSystem=\"knb\" order=\"allowFirst\">"
-                   +"<identifier>"+name+"</identifier>"
-                   +"<allow>"
-             +"<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
-                   +"<permission>all</permission>"
-                   +"</allow>"
-                   +"<allow>"
-                   +"<principal>public</principal>"
-                   +"<permission>read</permission>"
-                   +"</allow>"
-                   +"</acl>";
-     logMetacat.info("xml document: "+content);
-     assertTrue(handleXMLDocument(content, name, "update"));
-   
-  }
-  
-  /**
-   * Test insert a data file successfully
-   */
-  public void testInertDataFile()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"1";
-    logMetacat.info("insert data file docid: "+name);
-    logMetacat.info("insert data file ");
-    File hello = new File("test/jones.204.22.xml");
-   
-    assertTrue(insertDataFile(name, hello));
-  }
-  
-  /**
-   * Test delete a xml document successfully
-   */
-  public void testDeleteXMLDocument()
-  {
-    String name = "john"+MetaCatUtil.getOption("accNumSeparator")
-                     +serialNumber+MetaCatUtil.getOption("accNumSeparator")+"2";
-    logMetacat.info("delete docid: "+name);
-    assertTrue(handleDeleteFile(name));
-   
-  }
-  
-  
-       
-  /**
-   * Test logout action
-   */
-  public void testLogOut()
-  {
-    
-    assertTrue(handleLogOut());
-   
-  }
-  
- /**
-   * Method to hanld login action
-   *
-   * @param usrerName, the DN name of the test method
-   * @param passWord, the passwd of the user
-   */
-  
-  public boolean logIn(String userName, String passWord)
-  {
-    Properties prop = new Properties();
-    prop.put("action", "login");
-    prop.put("qformat", "xml");
-    prop.put("username", userName);
-    prop.put("password", passWord);
+		suite.addTest(new MetaCatServletNetTest("testDeleteXMLDocument", serial));
 
-    // Now contact metacat
-    String response = getMetacatString(prop);
-    logMetacat.info("Login Message: "+response);
-    boolean connected = false;
-    if (response.indexOf("<login>") != -1) {
-      connected = true;
-    } else {
-      
-      connected = false;
-    }
+		//insert invalid xml document
+		number = Math.random() * 100000;
+		serial = Integer.toString(((new Double(number)).intValue()));
+		suite
+				.addTest(new MetaCatServletNetTest("testInsertInvalidateXMLDocument",
+						serial));
+		//insert non well formed document
+		number = Math.random() * 100000;
+		serial = Integer.toString(((new Double(number)).intValue()));
+		suite.addTest(new MetaCatServletNetTest("testInsertNonWellFormedXMLDocument",
+				serial));
+		//insert data file  
+		number = Math.random() * 100000;
+		serial = Integer.toString(((new Double(number)).intValue()));
+		suite.addTest(new MetaCatServletNetTest("testLogOut"));
 
-    return connected;
-  }
-  
-  /**
-   * Method to hanld logout action
-   *
-   * @param usrerName, the DN name of the test method
-   * @param passWord, the passwd of the user
-   */
-  
-  public boolean handleLogOut()
-  {
-    boolean disConnected =false;
-    Properties prop = new Properties();
-    prop.put("action", "logout");
-    prop.put("qformat", "xml");
-  
-    String response = getMetacatString(prop);
-    logMetacat.info("Logout Message: "+response);
-    edu.ucsb.nceas.morpho.framework.HttpMessage.setCookie(null);
-     
-    if (response.indexOf("<logout>") != -1) 
-    {
-      disConnected = true;
-    } 
-    else 
-    {
-      disConnected = false;
-    }
+		return suite;
+	}
 
-    return disConnected;
-  }
-  
-  /**
-   * Method to hanld read both xml and data file
-   *
-   * @param docid, the docid of the document want to read
-   * @param qformat, the format of document user want to get
-   */
-  public boolean handleReadAction(String docid, String qformat)
-  {
-    Properties prop = new Properties();
-    String message ="";
-    prop.put("action", "read");
-    prop.put("qformat", qformat);
-    prop.put("docid", docid);
-    
-    message = getMetacatString(prop);
-    message = message.trim();
-    //MetaCatUtil.debugMessage("Read Message: "+message, 30);
-    if (message==null || message.equals("")||message.indexOf("<error>") != -1 )
-    {//there was an error
-      
-      return false;
-    }
-    else
-    {//successfully
-      return true;
-    } 
-    
-  }
-  
-  
-  /**
-   * Method to hanld inset or update xml document
-   *
-   * @param xmlDocument, the content of xml qformat
-   * @param docid, the docid of the document
-   * @param action, insert or update
-   */
-  public boolean handleXMLDocument(String xmlDocument, String docid, 
-                                                              String action)
- 
-  { //-attempt to write file to metacat
-    String access = "no";
-    StringBuffer fileText = new StringBuffer();
-    StringBuffer messageBuf = new StringBuffer();
-    String accessFileId = null;
-    Properties prop = new Properties();
-    prop.put("action", action);
-    prop.put("public", access);  //This is the old way of controlling access
-    prop.put("doctext", xmlDocument);
-    prop.put("docid", docid);
-    
-    String message = getMetacatString(prop);
-    logMetacat.info("Insert or Update Message: "+message);
-    if(message.indexOf("<error>") != -1)
-    {//there was an error
-      
-      return false;
-    }
-    else if(message.indexOf("<success>") != -1)
-    {//the operation worked
-     //write the file to the cache and return the file object
-     return true;
-       
-    }
-    else
-    {//something weird happened.
-      return false;
-    } 
-   
-   
-  }
-  
-   public boolean handleDeleteFile(String name)
-  {
-    
-    Properties prop = new Properties();
-    prop.put("action", "delete");
-    prop.put("docid", name);
- 
-    String message = getMetacatString(prop);
-    logMetacat.info("Delete Message: "+message);
-    if(message.indexOf("<error>") != -1)
-    {//there was an error
-      
-      return false;
-    }
-    else if(message.indexOf("<success>") != -1)
-    {//the operation worked
-     //write the file to the cache and return the file object
-     return true;
-       
-    }
-    else
-    {//something weird happened.
-      return false;
-    } 
-  }
-  
-  
-  /**
-   * sends a data file to the metacat using "multipart/form-data" encoding
-   *
-   * @param id the id to assign to the file on metacat (e.g., knb.1.1)
-   * @param file the file to send
-   */
-  public boolean insertDataFile(String id, File file)
-  {
-    String response = null;
-    //Get response for calling sendDataFile function
-    response = sendDataFile(id, file);
-    
-    if (response.indexOf("success") != -1)
-    {
-      //insert successfully
-      return true;
-    }
-    else
-    {
-      return false;
-    }
-  }
-  
-  /**
-   * sends a data file to the metacat using "multipart/form-data" encoding
-   *
-   * @param id the id to assign to the file on metacat (e.g., knb.1.1)
-   * @param file the file to send
-   */
-  public String sendDataFile(String id, File file) 
-  {
-    String response = "";
-    InputStream returnStream = null;
+	/**
+	 * Run an initial test that always passes to check that the test
+	 * harness is working.
+	 */
+	public void initialize() {
+		assertTrue(1 == 1);
+	}
 
-    // Now contact metacat and send the request
-    try
-    {
-      //FileInputStream data = new FileInputStream(file);
-      System.setProperty("java.protocol.handler.pkgs","HTTPClient");
-      URL url = new URL(metacatURL);
-      edu.ucsb.nceas.morpho.framework.HttpMessage msg = 
-                        new edu.ucsb.nceas.morpho.framework.HttpMessage(url);
-      Properties args = new Properties();
-      args.put("action", "upload");
-      args.put("docid", id);
+	/**
+	 * Test the login to neceas succesfully
+	 */
+	public void testNCEASLogin() {
+		String user = "uid=john,o=NCEAS,dc=ecoinformatics,dc=org";
+		String passwd = "123456";
+		assertTrue(logIn(user, passwd));
+		//assertTrue( withProtocol.getProtocol().equals("http"));
+	}
 
-      Properties dataStreams = new Properties();
-      String filename = file.getAbsolutePath();
-      System.out.println("the absolute path is "+filename);
-      dataStreams.put("datafile", filename);
-       
-  
-    
-      returnStream = msg.sendPostData(args, dataStreams);
-        
-      InputStreamReader returnStreamReader = 
-                        new InputStreamReader(returnStream);
-      StringWriter sw = new StringWriter();
-      int len;
-      char[] characters = new char[512];
-      while ((len = returnStreamReader.read(characters, 0, 512)) != -1)
-      {
-        sw.write(characters, 0, len);
-      }
-      returnStreamReader.close();
-      response = sw.toString();
-      sw.close();
-   
-    } 
-    catch(Exception e) 
-    {
-      e.printStackTrace(System.err);
-    }
-    return response;
-  }
-  
-  public String getMetacatString(Properties prop)
-  {
-    String response = null;
+	/**
+	 * Test the login to neceas failed
+	 */
+	public void testNCEASLoginFail() {
+		String user = "uid=john,o=NCEAS,dc=ecoinformatics,dc=org";
+		String passwd = "12345678";
+		assertTrue(!logIn(user, passwd));
 
-    // Now contact metacat and send the request
-    try
-    {
-      InputStreamReader returnStream = 
-                        new InputStreamReader(getMetacatInputStream(prop));
-      StringWriter sw = new StringWriter();
-      int len;
-      char[] characters = new char[512];
-      while ((len = returnStream.read(characters, 0, 512)) != -1)
-      {
-        sw.write(characters, 0, len);
-      }
-      returnStream.close();
-      response = sw.toString();
-      sw.close();
-    }
-    catch(Exception e)
-    {
-      return null;
-    }
-  
-    return response;
-  }
-  
-   /**
-   * Send a request to Metacat
-   *
-   * @param prop the properties to be sent to Metacat
-   * @return InputStream as returned by Metacat
-   */
-  public InputStream getMetacatInputStream(Properties prop)
-  {
-    InputStream returnStream = null;
-    // Now contact metacat and send the request
-    try
-    {
-     
-      URL url = new URL(metacatURL);
-      edu.ucsb.nceas.morpho.framework.HttpMessage msg = 
-              new edu.ucsb.nceas.morpho.framework.HttpMessage(url);
-      returnStream = msg.sendPostMessage(prop);
-      return returnStream;
-    }
-    catch(Exception e)
-    {
-      e.printStackTrace(System.err);
-     
-    }
-    return returnStream;
-   
-  }
+	}
 
- 
+	/**
+	 * Test the login to lter failed
+	 */
+	public void testLterReferralLoginFail() {
+		String user = "uid=jtao,o=LTER,dc=ecoinformatics,dc=org";
+		String passwd = "qVyGpveb";
+		assertTrue(!logIn(user, passwd));
+		//assertTrue( withProtocol.getProtocol().equals("http"));
+	}
 
+	/**
+	 * Test insert a xml document successfully
+	 */
+	public void testInsertXMLDocument() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		logMetacat.info("insert docid: " + name);
+		String content = "<?xml version=\"1.0\"?>"
+				+ "<!DOCTYPE acl PUBLIC \"-//ecoinformatics.org//"
+				+ "eml-access-2.0.0beta6//EN\" \"http://pine.nceas.ucsb."
+				+ "edu:8080/tao/dtd/eml-access-2.0.0beta6.dtd\">"
+				+ "<acl authSystem=\"knb\" order=\"allowFirst\">" + "<identifier>" + name
+				+ "</identifier>" + "<allow>"
+				+ "<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
+				+ "<permission>all</permission>" + "</allow>" + "<allow>"
+				+ "<principal>public</principal>" + "<permission>read</permission>"
+				+ "</allow>" + "</acl>";
+		logMetacat.info("xml document: " + content);
+		assertTrue(handleXMLDocument(content, name, "insert"));
+
+	}
+
+	/**
+	 * Test insert a invalidate xml document successfully
+	 * In the String, there is no <!Doctype ... Public/System/>
+	 */
+	public void testInsertInvalidateXMLDocument() throws PropertyNotFoundException  {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		logMetacat.info("insert docid: " + name);
+		String content = "<?xml version=\"1.0\"?>"
+				+ "<acl authSystem=\"knb\" order=\"allowFirst\">" + "<identifier>" + name
+				+ "</identifier>" + "<allow>"
+				+ "<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
+				+ "<permission>all</permission>" + "</allow>" + "<allow>"
+				+ "<principal>public</principal>" + "<permission>read</permission>"
+				+ "</allow>" + "</acl>";
+		logMetacat.info("xml document: " + content);
+		assertTrue(handleXMLDocument(content, name, "insert"));
+	}
+
+	/**
+	 * Test insert a non well-formed xml document successfully
+	 * There is no </acl> in this string
+	 */
+	public void testInsertNonWellFormedXMLDocument() throws PropertyNotFoundException  {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		logMetacat.info("insert non well-formed docid: " + name);
+		String content = "<?xml version=\"1.0\"?>"
+				+ "<acl authSystem=\"knb\" order=\"allowFirst\">" + "<identifier>" + name
+				+ "</identifier>" + "<allow>"
+				+ "<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
+				+ "<permission>all</permission>" + "</allow>" + "<allow>"
+				+ "<principal>public</principal>" + "<permission>read</permission>"
+				+ "</allow>";
+
+		logMetacat.info("xml document: " + content);
+		assertTrue(!handleXMLDocument(content, name, "insert"));
+	}
+
+	/**
+	 * Test read a xml document  in xml format successfully
+	 */
+	public void testReadXMLDocumentXMLFormat() throws PropertyNotFoundException  {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		assertTrue(handleReadAction(name, "xml"));
+
+	}
+
+	/**
+	 * Test read a xml document  in html format successfully
+	 */
+	public void testReadXMLDocumentHTMLFormat() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		assertTrue(handleReadAction(name, "html"));
+
+	}
+
+	/**
+	 * Test read a xml document  in zip format successfully
+	 */
+	public void testReadXMLDocumentZipFormat() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		assertTrue(handleReadAction(name, "zip"));
+
+	}
+
+	/**
+	 * Test insert a xml document successfully
+	 */
+	public void testUpdateXMLDocument() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "2";
+		logMetacat.info("update docid: " + name);
+		String content = "<?xml version=\"1.0\"?>"
+				+ "<!DOCTYPE acl PUBLIC \"-//ecoinformatics.org//"
+				+ "eml-access-2.0.0beta6//EN\" \"http://pine.nceas.ucsb."
+				+ "edu:8080/tao/dtd/eml-access-2.0.0beta6.dtd\">"
+				+ "<acl authSystem=\"knb\" order=\"allowFirst\">" + "<identifier>" + name
+				+ "</identifier>" + "<allow>"
+				+ "<principal>uid=john,o=NCEAS,dc=ecoinformatics,dc=org</principal>"
+				+ "<permission>all</permission>" + "</allow>" + "<allow>"
+				+ "<principal>public</principal>" + "<permission>read</permission>"
+				+ "</allow>" + "</acl>";
+		logMetacat.info("xml document: " + content);
+		assertTrue(handleXMLDocument(content, name, "update"));
+
+	}
+
+	/**
+	 * Test insert a data file successfully
+	 */
+	public void testInertDataFile() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "1";
+		logMetacat.info("insert data file docid: " + name);
+		logMetacat.info("insert data file ");
+		File hello = new File("test/jones.204.22.xml");
+
+		assertTrue(insertDataFile(name, hello));
+	}
+
+	/**
+	 * Test delete a xml document successfully
+	 */
+	public void testDeleteXMLDocument() throws PropertyNotFoundException {
+		String name = "john" + PropertyService.getProperty("accNumSeparator") + serialNumber
+				+ PropertyService.getProperty("accNumSeparator") + "2";
+		logMetacat.info("delete docid: " + name);
+		assertTrue(handleDeleteFile(name));
+
+	}
+
+	/**
+	 * Test logout action
+	 */
+	public void testLogOut() {
+
+		assertTrue(handleLogOut());
+
+	}
+
+	/**
+	 * Method to hanld login action
+	 *
+	 * @param usrerName, the DN name of the test method
+	 * @param passWord, the passwd of the user
+	 */
+
+	public boolean logIn(String userName, String passWord) {
+		Properties prop = new Properties();
+		prop.put("action", "login");
+		prop.put("qformat", "xml");
+		prop.put("username", userName);
+		prop.put("password", passWord);
+
+		// Now contact metacat
+		String response = getMetacatString(prop);
+		logMetacat.info("Login Message: " + response);
+		boolean connected = false;
+		if (response.indexOf("<login>") != -1) {
+			connected = true;
+		} else {
+
+			connected = false;
+		}
+
+		return connected;
+	}
+
+	/**
+	 * Method to hanld logout action
+	 *
+	 * @param usrerName, the DN name of the test method
+	 * @param passWord, the passwd of the user
+	 */
+
+	public boolean handleLogOut() {
+		boolean disConnected = false;
+		Properties prop = new Properties();
+		prop.put("action", "logout");
+		prop.put("qformat", "xml");
+
+		String response = getMetacatString(prop);
+		logMetacat.info("Logout Message: " + response);
+		edu.ucsb.nceas.morpho.framework.HttpMessage.setCookie(null);
+
+		if (response.indexOf("<logout>") != -1) {
+			disConnected = true;
+		} else {
+			disConnected = false;
+		}
+
+		return disConnected;
+	}
+
+	/**
+	 * Method to hanld read both xml and data file
+	 *
+	 * @param docid, the docid of the document want to read
+	 * @param qformat, the format of document user want to get
+	 */
+	public boolean handleReadAction(String docid, String qformat) {
+		Properties prop = new Properties();
+		String message = "";
+		prop.put("action", "read");
+		prop.put("qformat", qformat);
+		prop.put("docid", docid);
+
+		message = getMetacatString(prop);
+		message = message.trim();
+		//MetaCatUtil.debugMessage("Read Message: "+message, 30);
+		if (message == null || message.equals("") || message.indexOf("<error>") != -1) {//there was an error
+
+			return false;
+		} else {//successfully
+			return true;
+		}
+
+	}
+
+	/**
+	 * Method to hanld inset or update xml document
+	 *
+	 * @param xmlDocument, the content of xml qformat
+	 * @param docid, the docid of the document
+	 * @param action, insert or update
+	 */
+	public boolean handleXMLDocument(String xmlDocument, String docid, String action)
+
+	{ //-attempt to write file to metacat
+		String access = "no";
+		StringBuffer fileText = new StringBuffer();
+		StringBuffer messageBuf = new StringBuffer();
+		String accessFileId = null;
+		Properties prop = new Properties();
+		prop.put("action", action);
+		prop.put("public", access); //This is the old way of controlling access
+		prop.put("doctext", xmlDocument);
+		prop.put("docid", docid);
+
+		String message = getMetacatString(prop);
+		logMetacat.info("Insert or Update Message: " + message);
+		if (message.indexOf("<error>") != -1) {//there was an error
+
+			return false;
+		} else if (message.indexOf("<success>") != -1) {//the operation worked
+			//write the file to the cache and return the file object
+			return true;
+
+		} else {//something weird happened.
+			return false;
+		}
+
+	}
+
+	public boolean handleDeleteFile(String name) {
+
+		Properties prop = new Properties();
+		prop.put("action", "delete");
+		prop.put("docid", name);
+
+		String message = getMetacatString(prop);
+		logMetacat.info("Delete Message: " + message);
+		if (message.indexOf("<error>") != -1) {//there was an error
+
+			return false;
+		} else if (message.indexOf("<success>") != -1) {//the operation worked
+			//write the file to the cache and return the file object
+			return true;
+
+		} else {//something weird happened.
+			return false;
+		}
+	}
+
+	/**
+	 * sends a data file to the metacat using "multipart/form-data" encoding
+	 *
+	 * @param id the id to assign to the file on metacat (e.g., knb.1.1)
+	 * @param file the file to send
+	 */
+	public boolean insertDataFile(String id, File file) {
+		String response = null;
+		//Get response for calling sendDataFile function
+		response = sendDataFile(id, file);
+
+		if (response.indexOf("success") != -1) {
+			//insert successfully
+			return true;
+		} else {
+			return false;
+		}
+	}
+
+	/**
+	 * sends a data file to the metacat using "multipart/form-data" encoding
+	 *
+	 * @param id the id to assign to the file on metacat (e.g., knb.1.1)
+	 * @param file the file to send
+	 */
+	public String sendDataFile(String id, File file) {
+		String response = "";
+		InputStream returnStream = null;
+
+		// Now contact metacat and send the request
+		try {
+			//FileInputStream data = new FileInputStream(file);
+			System.setProperty("java.protocol.handler.pkgs", "HTTPClient");
+			URL url = new URL(metacatURL);
+			edu.ucsb.nceas.morpho.framework.HttpMessage msg = new edu.ucsb.nceas.morpho.framework.HttpMessage(
+					url);
+			Properties args = new Properties();
+			args.put("action", "upload");
+			args.put("docid", id);
+
+			Properties dataStreams = new Properties();
+			String filename = file.getAbsolutePath();
+			System.out.println("the absolute path is " + filename);
+			dataStreams.put("datafile", filename);
+
+			returnStream = msg.sendPostData(args, dataStreams);
+
+			InputStreamReader returnStreamReader = new InputStreamReader(returnStream);
+			StringWriter sw = new StringWriter();
+			int len;
+			char[] characters = new char[512];
+			while ((len = returnStreamReader.read(characters, 0, 512)) != -1) {
+				sw.write(characters, 0, len);
+			}
+			returnStreamReader.close();
+			response = sw.toString();
+			sw.close();
+
+		} catch (Exception e) {
+			e.printStackTrace(System.err);
+		}
+		return response;
+	}
+
+	public String getMetacatString(Properties prop) {
+		String response = null;
+
+		// Now contact metacat and send the request
+		try {
+			InputStreamReader returnStream = new InputStreamReader(
+					getMetacatInputStream(prop));
+			StringWriter sw = new StringWriter();
+			int len;
+			char[] characters = new char[512];
+			while ((len = returnStream.read(characters, 0, 512)) != -1) {
+				sw.write(characters, 0, len);
+			}
+			returnStream.close();
+			response = sw.toString();
+			sw.close();
+		} catch (Exception e) {
+			return null;
+		}
+
+		return response;
+	}
+
+	/**
+	 * Send a request to Metacat
+	 *
+	 * @param prop the properties to be sent to Metacat
+	 * @return InputStream as returned by Metacat
+	 */
+	public InputStream getMetacatInputStream(Properties prop) {
+		InputStream returnStream = null;
+		// Now contact metacat and send the request
+		try {
+
+			URL url = new URL(metacatURL);
+			edu.ucsb.nceas.morpho.framework.HttpMessage msg = new edu.ucsb.nceas.morpho.framework.HttpMessage(
+					url);
+			returnStream = msg.sendPostMessage(prop);
+			return returnStream;
+		} catch (Exception e) {
+			e.printStackTrace(System.err);
+
+		}
+		return returnStream;
+
+	}
+
 }
